angular.module('beamng.apps').directive('lookAhead', ['StreamsManager', 'bngApi', function (StreamsManager, bngApi) {
	return {
		template:  
		'<div>' +
		//'	<span>SteerDelta: {{ steer }}</span><br>' +
		'	<span>Sensitivity: {{ sensitivity }}</span><br>' +
		'	<input type="range" min="10" max="1000" step="10" ng-model="sensitivity"></input>' +
		'	<span>Center@: {{ center }}°</span><br>' +
		'	<input type="range" min="0" max="10" step="0.1" ng-model="center"></input>' +
		'</div>',
		replace: true,
		restrict: 'EA',
		link: function (scope, element, attrs) {
			'use strict';
			var requiredStreams = ['electrics'];
			StreamsManager.add(requiredStreams);
			scope.steer = 0;
			scope.sensitivity = 100;
			scope.center = 2.5;
			var oldsteer = 0;
			var oldrgear = 0;

			scope.$on('$destroy', function () {
				StreamsManager.remove(requiredStreams);
			});

			var lastCalledTime = Date.now();
			
			scope.$on('streamsUpdate', function (event, streams) {
				scope.steer = -Math.round(streams.electrics.steering-oldsteer);
				scope.steer /= scope.sensitivity;
				oldsteer = streams.electrics.steering;
				if(streams.electrics.reverse != oldrgear){
					bngApi.engineLua("camera.lookBack(0);");
				}
				oldrgear = streams.electrics.reverse;
				bngApi.engineScript("rotate_camera_horizontal("+ scope.steer +");");
				if((streams.electrics.steering >= -scope.center && streams.electrics.steering <= scope.center) && !streams.electrics.reverse){
					bngApi.engineLua("camera.resetCamera(0);");
				}
			});
		}
	};
}])